#include "Seeed_BME280.h" // Including libraries
#include <Wire.h>

float temp; //Create variables to store values
float p;
int H;

int dust_output;
float dust_voltage;
float dust;

int LED=7; //Dust and LED pin numbers
int DUSTpin=0;

BME280 bme280; //Create object of BME280 class

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600); 
  if(!bme280.init()) Serial.println("Error with connection!");

  //Change reference voltage from 5V to 1.1V 
  //option: INTERNAL for Arduino UNO
  //option: INTERNAL1V1 for Arduino Mega
  analogReference(INTERNAL1V1);
  pinMode(LED,OUTPUT);
  digitalWrite(LED,LOW); //Set 0V to LED pin 

  Serial.println("T (C) \t p (Pa) \t H (%) \t Dust (ug/m3)");

}

void loop() {
  // put your main code here, to run repeatedly:
  //Read temperature value and print to serial port
  temp=bme280.getTemperature();
  Serial.print(temp);
  Serial.print("\t");
  //Read pressure value and print to serial port
  p=bme280.getPressure()/100.0;
  Serial.print(p);
  Serial.print("\t");
  //Read humidity value and print to serial port
  H=bme280.getHumidity();
  Serial.print(H);
  Serial.print("\t");

  //Measure dust
  digitalWrite(LED,HIGH);
  delayMicroseconds(280);
  dust_output=analogRead(DUSTpin);
  digitalWrite(LED,LOW);

  //Calculate voltage
  //Multiply voltage by 11 because voltage divider was used
  dust_voltage = (1100.0/1024.0)*dust_output*11;
  //Calculate dust when voltage is higher than minimal
  if(dust_voltage>600) dust=(dust_voltage-600)*0.2; 
  else dust=0.0;
  Serial.println(dust);
  
  delay(1000);
}
